# Uses of Class
org.apache.sysds.runtime.instructions.Instruction

Packages that use Instruction
Package
Description
org.apache.sysds.api.jmlc
org.apache.sysds.hops.codegen
org.apache.sysds.hops.recompile
org.apache.sysds.lops.compile
org.apache.sysds.resource.cost
org.apache.sysds.runtime.controlprogram
org.apache.sysds.runtime.controlprogram.context
org.apache.sysds.runtime.controlprogram.federated
org.apache.sysds.runtime.controlprogram.parfor.opt
org.apache.sysds.runtime.instructions
org.apache.sysds.runtime.instructions.cp
org.apache.sysds.runtime.instructions.cpfile
org.apache.sysds.runtime.instructions.fed
org.apache.sysds.runtime.instructions.gpu
org.apache.sysds.runtime.instructions.ooc
org.apache.sysds.runtime.instructions.spark
org.apache.sysds.runtime.lineage
org.apache.sysds.runtime.util
org.apache.sysds.utils

## Uses of Instruction in org.apache.sysds.api.jmlc

Methods in org.apache.sysds.api.jmlc that return types with arguments of type Instruction
Modifier and Type
Method
Description
`static ArrayList<Instruction>`
JMLCUtils.`cleanupRuntimeInstructions(ArrayList<Instruction> insts, String... outputs)`
Cleanup runtime instructions, removing rmvar instructions for any of the given output variable names.
`static ArrayList<Instruction>`
JMLCUtils.`cleanupRuntimeInstructions(ArrayList<Instruction> insts, HashSet<String> outputs)`
Cleanup runtime instructions, removing rmvar instructions for any of the given output variable names.
Method parameters in org.apache.sysds.api.jmlc with type arguments of type Instruction
Modifier and Type
Method
Description
`static ArrayList<Instruction>`
JMLCUtils.`cleanupRuntimeInstructions(ArrayList<Instruction> insts, String... outputs)`
Cleanup runtime instructions, removing rmvar instructions for any of the given output variable names.
`static ArrayList<Instruction>`
JMLCUtils.`cleanupRuntimeInstructions(ArrayList<Instruction> insts, HashSet<String> outputs)`
Cleanup runtime instructions, removing rmvar instructions for any of the given output variable names.

## Uses of Instruction in org.apache.sysds.hops.codegen

Methods in org.apache.sysds.hops.codegen that return types with arguments of type Instruction
Modifier and Type
Method
Description
`static ArrayList<Instruction>`
SpoofCompiler.`generateCodeFromHopDAGsToInst(Hop root)`
`static ArrayList<Instruction>`
SpoofCompiler.`generateCodeFromHopDAGsToInst(StatementBlock sb, ArrayList<Hop> roots)`

## Uses of Instruction in org.apache.sysds.hops.recompile

Methods in org.apache.sysds.hops.recompile that return types with arguments of type Instruction
Modifier and Type
Method
Description
`static ArrayList<Instruction>`
Recompiler.`recompile(StatementBlock sb, ArrayList<Hop> hops, ExecutionContext ec, RecompileStatus status, boolean inplace, boolean replaceLit, boolean updateStats, boolean forceEt, boolean pred, Types.ExecType et, long tid)`
Core internal primitive for the dynamic recompilation of any DAGs/predicate, including all variants with slightly different configurations.
`static ArrayList<Instruction>`
Recompiler.`recompileHopsDag(Hop hop, LocalVariableMap vars, RecompileStatus status, boolean inplace, boolean replaceLit, long tid)`
`static ArrayList<Instruction>`
Recompiler.`recompileHopsDag(StatementBlock sb, ArrayList<Hop> hops, ExecutionContext ec, RecompileStatus status, boolean inplace, boolean replaceLit, long tid)`
`static ArrayList<Instruction>`
Recompiler.`recompileHopsDag(StatementBlock sb, ArrayList<Hop> hops, LocalVariableMap vars, RecompileStatus status, boolean inplace, boolean replaceLit, long tid)`
`static ArrayList<Instruction>`
Recompiler.`recompileHopsDag2Forced(Hop hop, long tid, Types.ExecType et)`
`static ArrayList<Instruction>`
Recompiler.`recompileHopsDag2Forced(StatementBlock sb, ArrayList<Hop> hops, long tid, Types.ExecType et)`
`static ArrayList<Instruction>`
Recompiler.`recompileHopsDagInstructions(Hop hop)`
`static ArrayList<Instruction>`
Recompiler.`recompileHopsDagInstructions(StatementBlock sb, ArrayList<Hop> hops)`

## Uses of Instruction in org.apache.sysds.lops.compile

Methods in org.apache.sysds.lops.compile that return types with arguments of type Instruction
Modifier and Type
Method
Description
`ArrayList<Instruction>`
Dag.`getJobs(StatementBlock sb, DMLConfig config)`
Method to compile a dag generically

## Uses of Instruction in org.apache.sysds.resource.cost

Methods in org.apache.sysds.resource.cost with parameters of type Instruction
Modifier and Type
Method
Description
`double`
CostEstimator.`getTimeEstimateInst(Instruction inst)`
`void`
CostEstimator.`maintainStats(Instruction inst)`
Keep the basic-block variable statistics updated and compute I/O cost.

## Uses of Instruction in org.apache.sysds.runtime.controlprogram

Methods in org.apache.sysds.runtime.controlprogram that return Instruction
Modifier and Type
Method
Description
`Instruction`
ProgramBlock.`getExitInstruction()`
`Instruction`
BasicProgramBlock.`getInstruction(int i)`
Methods in org.apache.sysds.runtime.controlprogram that return types with arguments of type Instruction
Modifier and Type
Method
Description
`ArrayList<Instruction>`
ForProgramBlock.`getFromInstructions()`
`ArrayList<Instruction>`
ForProgramBlock.`getIncrementInstructions()`
`ArrayList<Instruction>`
BasicProgramBlock.`getInstructions()`
`ArrayList<Instruction>`
IfProgramBlock.`getPredicate()`
`ArrayList<Instruction>`
WhileProgramBlock.`getPredicate()`
`ArrayList<Instruction>`
ForProgramBlock.`getToInstructions()`
Methods in org.apache.sysds.runtime.controlprogram with parameters of type Instruction
Modifier and Type
Method
Description
`void`
BasicProgramBlock.`addInstruction(Instruction inst)`
`void`
ProgramBlock.`setExitInstruction(Instruction rmVar)`
Method parameters in org.apache.sysds.runtime.controlprogram with type arguments of type Instruction
Modifier and Type
Method
Description
`void`
BasicProgramBlock.`addInstructions(ArrayList<Instruction> inst)`
`ScalarObject`
ProgramBlock.`executePredicate(ArrayList<Instruction> inst, Hop hops, boolean requiresRecompile, Types.ValueType retType, ExecutionContext ec)`
Executes given predicate instructions (incl recompilation if required)
`void`
ForProgramBlock.`setFromInstructions(ArrayList<Instruction> instructions)`
`void`
ForProgramBlock.`setIncrementInstructions(ArrayList<Instruction> instructions)`
`void`
BasicProgramBlock.`setInstructions(ArrayList<Instruction> inst)`
`void`
IfProgramBlock.`setPredicate(ArrayList<Instruction> predicate)`
`void`
WhileProgramBlock.`setPredicate(ArrayList<Instruction> predicate)`
`void`
ForProgramBlock.`setToInstructions(ArrayList<Instruction> instructions)`
Constructor parameters in org.apache.sysds.runtime.controlprogram with type arguments of type Instruction
Modifier
Constructor
Description
``
`IfProgramBlock(Program prog, ArrayList<Instruction> predicate)`
``
`WhileProgramBlock(Program prog, ArrayList<Instruction> predicate)`

## Uses of Instruction in org.apache.sysds.runtime.controlprogram.context

Methods in org.apache.sysds.runtime.controlprogram.context with parameters of type Instruction
Modifier and Type
Method
Description
`void`
ExecutionContext.`maintainLineageDebuggerInfo(Instruction inst)`
`void`
ExecutionContext.`traceLineage(Instruction inst)`

## Uses of Instruction in org.apache.sysds.runtime.controlprogram.federated

Methods in org.apache.sysds.runtime.controlprogram.federated with parameters of type Instruction
Modifier and Type
Method
Description
`void`
FederatedWorkloadAnalyzer.`incrementWorkload(ExecutionContext ec, long tid, Instruction ins)`

## Uses of Instruction in org.apache.sysds.runtime.controlprogram.parfor.opt

Method parameters in org.apache.sysds.runtime.controlprogram.parfor.opt with type arguments of type Instruction
Modifier and Type
Method
Description
`static boolean`
OptTreeConverter.`containsSparkInstruction(ArrayList<Instruction> instSet, boolean inclCPFile)`

## Uses of Instruction in org.apache.sysds.runtime.instructions

Methods in org.apache.sysds.runtime.instructions that return Instruction
Modifier and Type
Method
Description
`static Instruction[]`
InstructionParser.`parseMixedInstructions(String str)`
`static Instruction`
InstructionParser.`parseSingleInstruction(String str)`
`Instruction`
Instruction.`preprocessInstruction(ExecutionContext ec)`
This method should be used for any setup before executing this instruction.
Methods in org.apache.sysds.runtime.instructions with parameters of type Instruction
Modifier and Type
Method
Description
`void`
Instruction.`setLocation(Instruction oldInst)`

## Uses of Instruction in org.apache.sysds.runtime.instructions.cp

Subclasses of Instruction in org.apache.sysds.runtime.instructions.cp
Modifier and Type
Class
Description
`class`
`AggregateBinaryCPInstruction`
`class`
`AggregateTernaryCPInstruction`
`class`
`AggregateUnaryCPInstruction`
`class`
`AppendCPInstruction`
`class`
`BinaryCPInstruction`
`class`
`BinaryFrameFrameCPInstruction`
`class`
`BinaryFrameMatrixCPInstruction`
`class`
`BinaryFrameScalarCPInstruction`
`class`
`BinaryMatrixMatrixCPInstruction`
`class`
`BinaryMatrixScalarCPInstruction`
`class`
`BinaryScalarScalarCPInstruction`
`class`
`BinaryTensorTensorCPInstruction`
`class`
`BroadcastCPInstruction`
`class`
`BuiltinNaryCPInstruction`
Instruction to handle a variable number of input operands.
`class`
`CentralMomentCPInstruction`
`class`
`CompressionCPInstruction`
`class`
`ComputationCPInstruction`
`class`
`CovarianceCPInstruction`
`class`
`CPInstruction`
`class`
`CtableCPInstruction`
`class`
`DataGenCPInstruction`
`class`
`DeCompressionCPInstruction`
`class`
`DnnCPInstruction`
`class`
`EinsumCPInstruction`
`class`
`EvalNaryCPInstruction`
Eval built-in function instruction Note: it supports only single matrix[double] output
`class`
`EvictCPInstruction`
`final class`
`FrameAppendCPInstruction`
`final class`
`FrameIndexingCPInstruction`
`class`
`FunctionCallCPInstruction`
`class`
`IndexingCPInstruction`
`final class`
`ListAppendRemoveCPInstruction`
`final class`
`ListIndexingCPInstruction`
`class`
`LocalCPInstruction`
A simple instruction that take whatever input it is and return it as a local matrix.
`final class`
`MatrixAppendCPInstruction`
`class`
`MatrixBuiltinNaryCPInstruction`
`final class`
`MatrixIndexingCPInstruction`
`class`
`MMChainCPInstruction`
`class`
`MMTSJCPInstruction`
`class`
`MultiReturnBuiltinCPInstruction`
`class`
`MultiReturnComplexMatrixBuiltinCPInstruction`
`class`
`MultiReturnParameterizedBuiltinCPInstruction`
`class`
`ParameterizedBuiltinCPInstruction`
`class`
`ParamservBuiltinCPInstruction`
`class`
`PMMJCPInstruction`
`class`
`PrefetchCPInstruction`
`class`
`QuantilePickCPInstruction`
`class`
`QuantileSortCPInstruction`
This class supports two variants of sort operation on a 1-dimensional input matrix.
`class`
`QuaternaryCPInstruction`
`class`
`ReorgCPInstruction`
`class`
`ReshapeCPInstruction`
`final class`
`ScalarAppendCPInstruction`
`class`
`ScalarBuiltinNaryCPInstruction`
The ScalarBuiltinMultipleCPInstruction class is responsible for printf-style Java-based string formatting.
`class`
`SpoofCPInstruction`
`class`
`SqlCPInstruction`
`class`
`StringInitCPInstruction`
`class`
`TernaryCPInstruction`
`class`
`TernaryFrameScalarCPInstruction`
`class`
`UaggOuterChainCPInstruction`
`class`
`UnaryCPInstruction`
`class`
`UnaryFrameCPInstruction`
`class`
`UnaryMatrixCPInstruction`
`class`
`UnaryScalarCPInstruction`
`class`
`UnionCPInstruction`
`class`
`VariableCPInstruction`
Methods in org.apache.sysds.runtime.instructions.cp that return Instruction
Modifier and Type
Method
Description
`static Instruction`
VariableCPInstruction.`prepareCopyInstruction(String srcVar, String destVar)`
`static Instruction`
VariableCPInstruction.`prepareRemoveInstruction(long... varName)`
`static Instruction`
VariableCPInstruction.`prepareRemoveInstruction(String... varNames)`
`static Instruction`
VariableCPInstruction.`prepCreatevarInstruction(String varName, String fileName, boolean fNameOverride, String format)`
`static Instruction`
VariableCPInstruction.`prepCreatevarInstruction(String varName, String fileName, boolean fNameOverride, Types.DataType dt, String format, DataCharacteristics mc, MatrixObject.UpdateType update)`
`static Instruction`
VariableCPInstruction.`prepCreatevarInstruction(String varName, String fileName, boolean fNameOverride, Types.DataType dt, String format, DataCharacteristics mc, MatrixObject.UpdateType update, boolean hasHeader, String delim, boolean sparse)`
`static Instruction`
VariableCPInstruction.`prepMoveInstruction(String srcVar, String destVar)`
`static Instruction`
VariableCPInstruction.`prepMoveInstruction(String srcVar, String destFileName, String format)`
`Instruction`
CPInstruction.`preprocessInstruction(ExecutionContext ec)`
`Instruction`
FunctionCallCPInstruction.`preprocessInstruction(ExecutionContext ec)`

## Uses of Instruction in org.apache.sysds.runtime.instructions.cpfile

Subclasses of Instruction in org.apache.sysds.runtime.instructions.cpfile
Modifier and Type
Class
Description
`final class`
`MatrixIndexingCPFileInstruction`
This instruction is used if a single partition is too large to fit in memory.

## Uses of Instruction in org.apache.sysds.runtime.instructions.fed

Subclasses of Instruction in org.apache.sysds.runtime.instructions.fed
Modifier and Type
Class
Description
`class`
`AggregateBinaryFEDInstruction`
`class`
`AggregateTernaryFEDInstruction`
`class`
`AggregateUnaryFEDInstruction`
`class`
`AppendFEDInstruction`
`class`
`BinaryFEDInstruction`
`class`
`BinaryMatrixMatrixFEDInstruction`
`class`
`BinaryMatrixScalarFEDInstruction`
`class`
`CastFEDInstruction`
`class`
`CentralMomentFEDInstruction`
`class`
`ComputationFEDInstruction`
`class`
`CovarianceFEDInstruction`
`class`
`CtableFEDInstruction`
`class`
`CumulativeOffsetFEDInstruction`
`class`
`FEDInstruction`
`final class`
`IndexingFEDInstruction`
`class`
`InitFEDInstruction`
`class`
`MMChainFEDInstruction`
`class`
`MMFEDInstruction`
`class`
`MultiReturnParameterizedBuiltinFEDInstruction`
`class`
`ParameterizedBuiltinFEDInstruction`
`class`
`QuantilePickFEDInstruction`
`class`
`QuantileSortFEDInstruction`
`class`
`QuaternaryFEDInstruction`
`class`
`QuaternaryWCeMMFEDInstruction`
`class`
`QuaternaryWDivMMFEDInstruction`
`class`
`QuaternaryWSigmoidFEDInstruction`
`class`
`QuaternaryWSLossFEDInstruction`
`class`
`QuaternaryWUMMFEDInstruction`
`class`
`ReblockFEDInstruction`
`class`
`ReorgFEDInstruction`
`class`
`ReshapeFEDInstruction`
`class`
`SpoofFEDInstruction`
`class`
`TernaryFEDInstruction`
`class`
`TernaryFrameScalarFEDInstruction`
`class`
`TsmmFEDInstruction`
`class`
`UnaryFEDInstruction`
`class`
`UnaryMatrixFEDInstruction`
`class`
`VariableFEDInstruction`
Methods in org.apache.sysds.runtime.instructions.fed that return Instruction
Modifier and Type
Method
Description
`static Instruction`
FEDInstructionUtils.`checkAndReplaceCP(Instruction inst, ExecutionContext ec)`
Check and replace CP instructions with federated instructions if the instruction match criteria.
`static Instruction`
FEDInstructionUtils.`checkAndReplaceSP(Instruction inst, ExecutionContext ec)`
Methods in org.apache.sysds.runtime.instructions.fed with parameters of type Instruction
Modifier and Type
Method
Description
`static Instruction`
FEDInstructionUtils.`checkAndReplaceCP(Instruction inst, ExecutionContext ec)`
Check and replace CP instructions with federated instructions if the instruction match criteria.
`static Instruction`
FEDInstructionUtils.`checkAndReplaceSP(Instruction inst, ExecutionContext ec)`

## Uses of Instruction in org.apache.sysds.runtime.instructions.gpu

Subclasses of Instruction in org.apache.sysds.runtime.instructions.gpu
Modifier and Type
Class
Description
`class`
`AggregateBinaryGPUInstruction`
`class`
`AggregateUnaryGPUInstruction`
Implements aggregate unary instructions for CUDA
`class`
`ArithmeticBinaryGPUInstruction`
`class`
`BuiltinBinaryGPUInstruction`
`class`
`BuiltinUnaryGPUInstruction`
`class`
`DnnGPUInstruction`
`class`
`GPUInstruction`
`class`
`MatrixAppendGPUInstruction`
Implements the cbind and rbind functions for matrices
`class`
`MatrixBuiltinGPUInstruction`
`class`
`MatrixIndexingGPUInstruction`
`class`
`MatrixMatrixArithmeticGPUInstruction`
`class`
`MatrixMatrixAxpyGPUInstruction`
`class`
`MatrixMatrixBuiltinGPUInstruction`
`class`
`MatrixMatrixRelationalBinaryGPUInstruction`
`class`
`MatrixReshapeGPUInstruction`
`class`
`MMTSJGPUInstruction`
`class`
`RelationalBinaryGPUInstruction`
`class`
`ReorgGPUInstruction`
`class`
`ScalarMatrixArithmeticGPUInstruction`
`class`
`ScalarMatrixBuiltinGPUInstruction`
`class`
`ScalarMatrixRelationalBinaryGPUInstruction`
`class`
`SpoofCUDAInstruction`
Methods in org.apache.sysds.runtime.instructions.gpu that return Instruction
Modifier and Type
Method
Description
`Instruction`
GPUInstruction.`preprocessInstruction(ExecutionContext ec)`

## Uses of Instruction in org.apache.sysds.runtime.instructions.ooc

Subclasses of Instruction in org.apache.sysds.runtime.instructions.ooc
Modifier and Type
Class
Description
`class`
`AggregateTernaryOOCInstruction`
`class`
`AggregateUnaryOOCInstruction`
`class`
`AppendOOCInstruction`
`class`
`BinaryOOCInstruction`
`class`
`CentralMomentOOCInstruction`
`class`
`ComputationOOCInstruction`
`class`
`CSVReblockOOCInstruction`
`class`
`CtableOOCInstruction`
`class`
`DataGenOOCInstruction`
`class`
`IndexingOOCInstruction`
`class`
`MapMMChainOOCInstruction`
`class`
`MatrixIndexingOOCInstruction`
`class`
`MMultOOCInstruction`
`class`
`OOCInstruction`
`class`
`ParameterizedBuiltinOOCInstruction`
`class`
`QuaternaryOOCInstruction`
`class`
`ReblockOOCInstruction`
`class`
`ReorgOOCInstruction`
`class`
`ReshapeOOCInstruction`
`class`
`TeeOOCInstruction`
`class`
`TernaryOOCInstruction`
`class`
`TSMMOOCInstruction`
`class`
`UnaryOOCInstruction`
`class`
`WDivMMOOCInstruction`
Methods in org.apache.sysds.runtime.instructions.ooc that return Instruction
Modifier and Type
Method
Description
`Instruction`
OOCInstruction.`preprocessInstruction(ExecutionContext ec)`

## Uses of Instruction in org.apache.sysds.runtime.instructions.spark

Subclasses of Instruction in org.apache.sysds.runtime.instructions.spark
Modifier and Type
Class
Description
`class`
`AggregateBinarySPInstruction`
Class to group the different MM `SPInstruction`s together.
`class`
`AggregateTernarySPInstruction`
`class`
`AggregateUnarySketchSPInstruction`
`class`
`AggregateUnarySPInstruction`
`class`
`AppendGAlignedSPInstruction`
`class`
`AppendGSPInstruction`
`class`
`AppendMSPInstruction`
`class`
`AppendRSPInstruction`
`class`
`AppendSPInstruction`
Class to group the different append `SPInstruction`s together.
`class`
`BinaryFrameFrameSPInstruction`
`class`
`BinaryFrameMatrixSPInstruction`
`class`
`BinaryMatrixBVectorSPInstruction`
`class`
`BinaryMatrixMatrixSPInstruction`
`class`
`BinaryMatrixScalarSPInstruction`
`class`
`BinarySPInstruction`
`class`
`BinaryTensorTensorBroadcastSPInstruction`
`class`
`BinaryTensorTensorSPInstruction`
`class`
`BinUaggChainSPInstruction`
Instruction that performs res = X / rowsum(x)
`class`
`BuiltinNarySPInstruction`
`class`
`CastSPInstruction`
`class`
`CentralMomentSPInstruction`
`class`
`CheckpointSPInstruction`
`class`
`CompressionSPInstruction`
`class`
`ComputationSPInstruction`
`class`
`CovarianceSPInstruction`
`class`
`CpmmSPInstruction`
Cpmm: cross-product matrix multiplication operation (distributed matrix multiply by join over common dimension and subsequent aggregation of partial results).
`class`
`CSVReblockSPInstruction`
`class`
`CtableSPInstruction`
`class`
`CumulativeAggregateSPInstruction`
`class`
`CumulativeOffsetSPInstruction`
`class`
`DeCompressionSPInstruction`
`class`
`DnnSPInstruction`
`class`
`FrameAppendMSPInstruction`
`class`
`FrameAppendRSPInstruction`
`class`
`FrameIndexingSPInstruction`
This class implements the frame indexing functionality inside Spark.
`class`
`IndexingSPInstruction`
This class implements the matrix indexing functionality inside Spark.
`class`
`LIBSVMReblockSPInstruction`
`class`
`MapmmChainSPInstruction`
`class`
`MapmmSPInstruction`
`class`
`MatrixAppendMSPInstruction`
`class`
`MatrixAppendRSPInstruction`
`class`
`MatrixIndexingSPInstruction`
This class implements the matrix indexing functionality inside CP.
`class`
`MatrixReshapeSPInstruction`
`class`
`MultiReturnParameterizedBuiltinSPInstruction`
`class`
`ParameterizedBuiltinSPInstruction`
`class`
`PMapmmSPInstruction`
This pmapmm matrix multiplication instruction is still experimental not integrated in automatic operator selection yet.
`class`
`PmmSPInstruction`
`class`
`QuantilePickSPInstruction`
`class`
`QuantileSortSPInstruction`
This class supports two variants of sort operation on a 1-dimensional input matrix.
`class`
`QuaternarySPInstruction`
`class`
`RandSPInstruction`
`class`
`ReblockSPInstruction`
`class`
`ReorgSPInstruction`
`class`
`RmmSPInstruction`
`class`
`SPInstruction`
`class`
`SpoofSPInstruction`
`class`
`TernaryFrameScalarSPInstruction`
`class`
`TernarySPInstruction`
`class`
`Tsmm2SPInstruction`
`class`
`TsmmSPInstruction`
`class`
`UaggOuterChainSPInstruction`
Two types of broadcast variables used -- 1.
`class`
`UnaryFrameSPInstruction`
`class`
`UnaryMatrixSPInstruction`
`class`
`UnarySPInstruction`
`class`
`WriteSPInstruction`
`class`
`ZipmmSPInstruction`
Methods in org.apache.sysds.runtime.instructions.spark that return Instruction
Modifier and Type
Method
Description
`Instruction`
SPInstruction.`preprocessInstruction(ExecutionContext ec)`

## Uses of Instruction in org.apache.sysds.runtime.lineage

Methods in org.apache.sysds.runtime.lineage with parameters of type Instruction
Modifier and Type
Method
Description
`static boolean`
LineageRewriteReuse.`executeRewrites(Instruction curr, ExecutionContext ec)`
`static boolean`
LineageCacheConfig.`isOutputFederated(Instruction inst, Data data)`
`static boolean`
LineageCacheConfig.`isReusable(Instruction inst, ExecutionContext ec)`
`static void`
LineageDebugger.`maintainSpecialValueBits(Lineage lineage, Instruction inst, ExecutionContext ec)`
`static void`
LineageEstimator.`processSingleInst(Instruction inst, ExecutionContext ec, long starttime)`
`static void`
LineageCache.`putMatrix(Instruction inst, ExecutionContext ec, long computetime)`
`static void`
LineageCache.`putValue(Instruction inst, ExecutionContext ec, long starttime)`
`static boolean`
LineageCache.`reuse(Instruction inst, ExecutionContext ec)`
`void`
Lineage.`trace(Instruction inst, ExecutionContext ec)`
`void`
LineageMap.`trace(Instruction inst, ExecutionContext ec)`
Method parameters in org.apache.sysds.runtime.lineage with type arguments of type Instruction
Modifier and Type
Method
Description
`static boolean`
LineageItemUtils.`hasValidInsts(ArrayList<Instruction> insts)`

## Uses of Instruction in org.apache.sysds.runtime.util

Methods in org.apache.sysds.runtime.util that return Instruction
Modifier and Type
Method
Description
`static Instruction`
ProgramConverter.`cloneInstruction(Instruction oInst, long pid, boolean plain, boolean cpFunctions)`
Methods in org.apache.sysds.runtime.util that return types with arguments of type Instruction
Modifier and Type
Method
Description
`static ArrayList<Instruction>`
ProgramConverter.`createDeepCopyInstructionSet(ArrayList<Instruction> instSet, long pid, int IDPrefix, Program prog, Set<String> fnStack, Set<String> fnCreated, boolean plain, boolean cpFunctions)`
Creates a deep copy of an array of instructions and replaces the placeholders of parworker IDs with the concrete IDs of this parfor instance.
`static ArrayList<Instruction>`
ProgramConverter.`createShallowCopyInstructionSet(ArrayList<Instruction> insts, long pid)`
Methods in org.apache.sysds.runtime.util with parameters of type Instruction
Modifier and Type
Method
Description
`static Instruction`
ProgramConverter.`cloneInstruction(Instruction oInst, long pid, boolean plain, boolean cpFunctions)`
Method parameters in org.apache.sysds.runtime.util with type arguments of type Instruction
Modifier and Type
Method
Description
`static ArrayList<Instruction>`
ProgramConverter.`createDeepCopyInstructionSet(ArrayList<Instruction> instSet, long pid, int IDPrefix, Program prog, Set<String> fnStack, Set<String> fnCreated, boolean plain, boolean cpFunctions)`
Creates a deep copy of an array of instructions and replaces the placeholders of parworker IDs with the concrete IDs of this parfor instance.
`static ArrayList<Instruction>`
ProgramConverter.`createShallowCopyInstructionSet(ArrayList<Instruction> insts, long pid)`

## Uses of Instruction in org.apache.sysds.utils

Methods in org.apache.sysds.utils with parameters of type Instruction
Modifier and Type
Method
Description
`static String`
Explain.`explain(Instruction inst)`
`static String`
Statistics.`getCPHeavyHitterCode(Instruction inst)`
`static void`
Statistics.`maintainNGramsFromLineage(Instruction tmp, ExecutionContext ec, long t0)`
Method parameters in org.apache.sysds.utils with type arguments of type Instruction
Modifier and Type
Method
Description
`static String`
Explain.`explain(List<Instruction> inst)`
`static String`
Explain.`explain(List<Instruction> inst, int level)`